"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var async_1 = __importDefault(require("async"));
var chokidar_1 = __importDefault(require("chokidar"));
var path_1 = __importDefault(require("path"));
var qs_1 = __importDefault(require("qs"));
var logger_1 = __importDefault(require("../lib/logger"));
var readTpl_1 = __importDefault(require("../lib/readTpl"));
var util_1 = __importDefault(require("../lib/util"));
var buildMods_1 = __importDefault(require("./build/buildMods"));
var output_1 = __importDefault(require("./build/output"));
var scanSrc_1 = __importDefault(require("./build/scanSrc"));
function build(options, cb) {
    transArrOpts(options);
    transTranspilerOpt(options, cb);
    handleEmptyFiles(options);
    resolvePaths(options);
    var templates;
    build(options.watch);
    if (options.watch) {
        var watchPaths = options.files.concat(options.libPaths);
        chokidar_1["default"]
            .watch(watchPaths, {
            persistent: true,
            ignored: options.output,
            ignoreInitial: true,
            followSymlinks: true,
            usePolling: true,
            alwaysStat: false,
            interval: 100,
            atomic: true,
            ignorePermissionErrors: false
        })
            .on('change', function () {
            build(true);
        });
    }
    function build(isWatching) {
        options.data = {};
        var startTime = util_1["default"].now();
        async_1["default"].waterfall([
            function (cb) {
                var tplList = ['code', 'codes'];
                var format = options.format;
                if (format !== 'commonjs' && format !== 'es') {
                    tplList.push(format);
                }
                readTpl_1["default"](tplList, cb);
            },
            function (tpl, cb) {
                templates = tpl;
                cb();
            },
            function (cb) {
                scanSrc_1["default"](options, cb);
            },
            function (fnList, cb) {
                buildMods_1["default"](fnList, templates.code, options, cb);
            },
            function (codes, cb) {
                return __awaiter(this, void 0, void 0, function () {
                    var result, e_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                result = '';
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4, output_1["default"](codes, templates.codes, templates[options.format], options)];
                            case 2:
                                result = _a.sent();
                                return [3, 4];
                            case 3:
                                e_1 = _a.sent();
                                return [2, cb(e_1)];
                            case 4:
                                cb(null, result);
                                return [2];
                        }
                    });
                });
            }
        ], function (err, result) {
            if (err) {
                if (isWatching) {
                    return logger_1["default"].error(err);
                }
                return cb(err);
            }
            logger_1["default"].info('TIME COST ' + (util_1["default"].now() - startTime) + 'ms.');
            cb(null, result);
        });
    }
}
exports["default"] = build;
;
build.defOpts = {
    namespace: '_',
    format: 'umd',
    output: './util' + '.js',
    extension: 'js',
    strict: false,
    ts: false,
    transpiler: [],
    files: [],
    ignore: [],
    library: [],
    include: [],
    exclude: [],
    sourcemap: false,
    watch: false,
    removeComments: false
};
function transArrOpts(options) {
    var ARR_OPTIONS = [
        'library',
        'include',
        'exclude',
        'ignore',
        'files',
        'extension',
        'transpiler'
    ];
    ARR_OPTIONS.forEach(function (key) {
        options[key] = util_1["default"].toArr(options[key]);
    });
}
function transTranspilerOpt(options, cb) {
    var cwd = options.cwd;
    options.transpiler.forEach(function (transpiler) {
        transpiler.handler = util_1["default"].toArr(transpiler.handler);
        var handlers = transpiler.handler;
        util_1["default"].each(handlers, function (handler, idx) {
            if (util_1["default"].isStr(handler)) {
                handler = handler.split('?');
                var handlerName = handler[0];
                var options_1 = {};
                if (handler[1]) {
                    options_1 = qs_1["default"].parse(handler[1]);
                }
                try {
                    var requirePath = path_1["default"].resolve(cwd, 'node_modules/eustia-' + handlerName);
                    handlers[idx] = require(requirePath)(options_1);
                }
                catch (e) {
                    cb(e);
                }
            }
        });
    });
}
function handleEmptyFiles(options) {
    if (util_1["default"].isEmpty(options.files) && util_1["default"].isEmpty(options.include)) {
        options.files = ['./*.html', './*.js'];
    }
}
function resolvePaths(options) {
    options.files = options.files.map(function (val) {
        return path_1["default"].resolve(options.cwd, val);
    });
    options.output = path_1["default"].resolve(options.cwd, options.output);
    var libPaths = [];
    if (!util_1["default"].isBrowser) {
        libPaths.push(path_1["default"].resolve(options.cwd, 'eustia'));
        libPaths.push(options.cacheDir);
    }
    options.library.forEach(function (library) {
        if (util_1["default"].isStr(library)) {
            if (!util_1["default"].isUrl(library)) {
                library = path_1["default"].resolve(library);
            }
            libPaths.push(library);
        }
        else if (util_1["default"].isFn(library)) {
            libPaths.push(library);
        }
    });
    libPaths.push('https://cdn.jsdelivr.net/npm/eustia-module@latest/');
    options.libPaths = libPaths;
    logger_1["default"].log('LIBRARY PATHS');
    logger_1["default"].color(libPaths.join('\n'), 'cyan');
}
