"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var axios_1 = __importDefault(require("axios"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var path_1 = require("path");
var request_promise_1 = __importDefault(require("request-promise"));
var logger_1 = __importDefault(require("../../lib/logger"));
var util_1 = __importDefault(require("../../lib/util"));
var regDependency = /\s*\b_\(\s*['"]([\w\s$]+)['"]\s*\);?/m;
var regExports = /\bexports\b/;
function default_1(modName, codeTpl, options) {
    return __awaiter(this, void 0, void 0, function () {
        var fnPercentage, percentage, result, paths, data, path, i, len, proxy, e_1, dependencies;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fnPercentage = options.data.fnPercentage;
                    if (util_1["default"].has(fnPercentage, modName)) {
                        percentage = fnPercentage[modName];
                    }
                    percentage = percentage ? ' (' + percentage + ')' : '';
                    result = {};
                    paths = [];
                    util_1["default"].each(options.libPaths, function (libPath) {
                        if (util_1["default"].isFn(libPath)) {
                            libPath = libPath(modName);
                        }
                        util_1["default"].each(options.extension, function (extension) {
                            var path;
                            if (util_1["default"].isUrl(libPath)) {
                                path = libPath + modName + '.' + extension;
                            }
                            else {
                                path = path_1.resolve(libPath, modName + '.' + extension);
                            }
                            paths.push(path);
                        });
                    });
                    i = 0, len = paths.length;
                    _a.label = 1;
                case 1:
                    if (!(i < len)) return [3, 17];
                    path = paths[i];
                    if (!util_1["default"].isUrl(path)) return [3, 13];
                    logger_1["default"].tpl({
                        modName: modName,
                        path: path
                    }, 'DOWNLOAD {{#cyan}}{{{modName}}}{{/cyan}} FROM {{{path}}}');
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 11, , 12]);
                    if (!util_1["default"].isBrowser) return [3, 4];
                    return [4, axios_1["default"].get(path)];
                case 3:
                    data = (_a.sent()).data;
                    return [3, 17];
                case 4:
                    proxy = options.proxy;
                    if (!proxy) return [3, 6];
                    return [4, request_promise_1["default"].get(path, { proxy: proxy })];
                case 5:
                    data = _a.sent();
                    return [3, 8];
                case 6: return [4, request_promise_1["default"].get(path)];
                case 7:
                    data = _a.sent();
                    _a.label = 8;
                case 8: return [4, fs_extra_1["default"].mkdirp(options.cacheDir)];
                case 9:
                    _a.sent();
                    return [4, fs_extra_1["default"].writeFile(path_1.resolve(options.cacheDir, path.split('/').pop()), data, 'utf8')];
                case 10:
                    _a.sent();
                    return [3, 17];
                case 11:
                    e_1 = _a.sent();
                    logger_1["default"].tpl({
                        modName: modName,
                        path: path
                    }, 'DOWNLOAD {{#cyan}}{{{modName}}}{{/cyan}} FROM {{{path}}} FAILED!');
                    throw e_1;
                case 12: return [3, 16];
                case 13: return [4, fs_extra_1["default"].pathExists(path)];
                case 14:
                    if (!_a.sent()) return [3, 16];
                    return [4, fs_extra_1["default"].readFile(path, options.encoding)];
                case 15:
                    data = _a.sent();
                    return [3, 17];
                case 16:
                    i++;
                    return [3, 1];
                case 17:
                    if (!data) {
                        throw new Error('There is no module named "' + modName + '"');
                    }
                    result.source = data;
                    data = transData(path, data, modName, options);
                    dependencies = regDependency.exec(data);
                    dependencies = dependencies ? util_1["default"].trim(dependencies[1]).split(/\s+/) : [];
                    data = util_1["default"].indent(data.replace(regDependency, '\n\n/* dependencies\n * $1 \n */'));
                    if (options.ts) {
                        result.ts = extractTs(data);
                    }
                    if (options.removeComments) {
                        data = util_1["default"].stripCmt(data);
                    }
                    data = codeTpl({
                        name: modName,
                        code: util_1["default"].trim(data),
                        es: options.format === 'es',
                        hasExports: regExports.test(data)
                    });
                    result.dependencies = dependencies;
                    result.name = modName;
                    result.code = data;
                    logger_1["default"].tpl({
                        modName: modName,
                        percentage: percentage,
                        dependencies: util_1["default"].isEmpty(dependencies)
                            ? ''
                            : ' <= ' + dependencies.join(' ')
                    }, 'BUILD MODULE {{#cyan}}{{{modName}}}{{/cyan}}{{{dependencies}}}{{{percentage}}}');
                    return [2, result];
            }
        });
    });
}
exports["default"] = default_1;
function transData(filePath, src, modName, options) {
    var transpiler = options.transpiler;
    util_1["default"].each(transpiler, function (item) {
        if (item.exclude && item.exclude.test(filePath)) {
            return;
        }
        if (item.test.test(filePath)) {
            util_1["default"].each(item.handler, function (handler) {
                src = handler.call(item, src, modName);
            });
        }
    });
    return src;
}
function extractTs(code) {
    var ret = '';
    var comments = util_1["default"].extractBlockCmts(code);
    util_1["default"].each(comments, function (comment) {
        var lines = util_1["default"].trim(comment).split('\n');
        if (util_1["default"].trim(lines[0]) !== 'typescript') {
            return;
        }
        lines.shift();
        ret = indentOneSpace(lines.join('\n'));
    });
    return ret;
}
var regStartOneSpace = /^ /gm;
function indentOneSpace(data) {
    return data.replace(regStartOneSpace, '');
}
