"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var fs_extra_1 = __importDefault(require("fs-extra"));
var path_1 = __importDefault(require("path"));
var logger_1 = __importDefault(require("../../lib/logger"));
var util_1 = __importDefault(require("../../lib/util"));
var source_map_1 = require("source-map");
function default_1(codes, codesTpl, formatTpl, options) {
    return __awaiter(this, void 0, void 0, function () {
        var code, tsResult, dependencyGraph, allDependencies, codesMap, codesOrder, map, i, len, name, ts, c, codesData, excludeRef, result, output, lastDotPos;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    code = '';
                    tsResult = '/* tslint:disable */\n\n';
                    dependencyGraph = [];
                    allDependencies = [];
                    codesMap = {};
                    map = new source_map_1.SourceMapGenerator({
                        file: "eustia:///eustia/" + path_1["default"].basename(options.output)
                    });
                    codes = codes.sort(function (a, b) {
                        if (a.name < b.name) {
                            return -1;
                        }
                        if (a.name > b.name) {
                            return 1;
                        }
                        return 0;
                    });
                    util_1["default"].each(codes, function (code) {
                        var dependencies = code.dependencies;
                        dependencyGraph.push(['', code.name]);
                        util_1["default"].each(dependencies, function (dependency) {
                            dependencyGraph.push([dependency, code.name]);
                            allDependencies.push(dependency);
                        });
                        codesMap[code.name] = code;
                    });
                    allDependencies = util_1["default"].unique(allDependencies);
                    codesOrder = util_1["default"].topoSort(dependencyGraph);
                    codesOrder.shift();
                    for (i = 0, len = codesOrder.length; i < len; i++) {
                        name = codesOrder[i];
                        ts = codesMap[name].ts;
                        c = codesMap[name].code;
                        if (options.ts) {
                            if (ts) {
                                tsResult += ts + '\n\n';
                            }
                        }
                        if (!util_1["default"].contain(allDependencies, name) && options.format !== 'es') {
                            c = util_1["default"].trim(c.replace(new RegExp('^\\s*var ' + util_1["default"].escapeRegExp(name) + ' = ', 'm'), ''));
                        }
                        code += c;
                        if (i !== len - 1) {
                            code += '\n\n';
                        }
                    }
                    codesData = {
                        code: code,
                        namespace: options.namespace,
                        strict: options.strict,
                        commonjs: options.format === 'commonjs',
                        es: options.format === 'es',
                        inBrowser: options.format === 'umd' || options.format === 'global'
                    };
                    excludeRef = options.data.excludeRef;
                    if (excludeRef.length > 0) {
                        excludeRef = excludeRef.sort();
                        codesData.excludeRef = util_1["default"].unique(excludeRef);
                    }
                    result = codesTpl(codesData);
                    result = result.replace(/\n\s*\n/g, '\n\n');
                    if (options.format !== 'commonjs' && options.format !== 'es') {
                        result = util_1["default"].indent(result);
                        result = formatTpl({
                            namespace: options.namespace,
                            codes: result
                        });
                    }
                    result = options.magicNum + '\n' + result;
                    logger_1["default"].tpl({
                        data: codesOrder.sort().join(' ')
                    }, 'MODULES GENERATED\n{{#cyan}}{{{data}}}{{/cyan}}');
                    logger_1["default"].tpl({
                        output: options.output
                    }, 'OUTPUT FILE {{#cyan}}{{{output}}}{{/cyan}}');
                    if (options.sourcemap) {
                        genSourceMap(map, result, codesMap, codesOrder);
                        result += "\n//# sourceMappingURL=" + path_1["default"].basename(options.output) + ".map";
                    }
                    if (util_1["default"].isBrowser)
                        return [2, result];
                    return [4, fs_extra_1["default"].writeFile(options.output, result, options.encoding)];
                case 1:
                    _a.sent();
                    if (!options.sourcemap) return [3, 3];
                    return [4, fs_extra_1["default"].writeFile(options.output + '.map', map.toString(), 'utf8')];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    if (!options.ts) return [3, 5];
                    output = options.output;
                    lastDotPos = output.lastIndexOf('.');
                    if (lastDotPos > -1) {
                        output = output.slice(0, lastDotPos);
                    }
                    output += '.d.ts';
                    logger_1["default"].tpl({
                        output: output
                    }, 'OUTPUT d.ts {{#cyan}}{{{output}}}{{/cyan}}');
                    return [4, fs_extra_1["default"].writeFile(output, tsResult, options.encoding)];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5: return [2, result];
            }
        });
    });
}
exports["default"] = default_1;
function genSourceMap(map, result, codesMap, codesOrder) {
    var resultMap = {};
    var lines = result.split(/\n/);
    var curName = 'unknown';
    for (var i = 0, len = lines.length; i < len; i++) {
        var line = lines[i];
        var match = line.match(/\/\* -{30} ([$\w]+) -{30} \*\//);
        if (match) {
            curName = match[1];
        }
        var originalLen = line.length;
        line = util_1["default"].ltrim(line);
        var column = originalLen - line.length;
        line = util_1["default"].rtrim(line);
        if (line) {
            var name = line + (" " + curName);
            if (!resultMap[name])
                resultMap[name] = [];
            resultMap[name].push({
                column: column,
                line: i + 1
            });
        }
    }
    for (var i = 0, len = codesOrder.length; i < len; i++) {
        var name = codesOrder[i];
        var source = "eustia:///" + name + ".js";
        var data = codesMap[name].source;
        map.setSourceContent(source, data);
        var lines_1 = data.split(/\n/);
        for (var i_1 = 0, len_1 = lines_1.length; i_1 < len_1; i_1++) {
            var line = lines_1[i_1];
            var originalLen = line.length;
            line = util_1["default"].ltrim(line);
            var column = originalLen - line.length;
            line = util_1["default"].rtrim(line);
            if (line) {
                var result_1 = resultMap[line + (" " + name)];
                if (result_1)
                    result_1 = result_1.shift();
                if (result_1) {
                    map.addMapping({
                        source: source,
                        generated: { line: result_1.line, column: result_1.column },
                        original: { line: i_1 + 1, column: column }
                    });
                }
            }
        }
    }
}
