"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var async_1 = __importDefault(require("async"));
var path_1 = __importDefault(require("path"));
var readTpl_1 = __importDefault(require("../lib/readTpl"));
var extractCmt_1 = __importDefault(require("./doc/extractCmt"));
var output_1 = __importDefault(require("./doc/output"));
var readDesc_1 = __importDefault(require("./doc/readDesc"));
function doc(options, cb) {
    var template;
    var ast = {};
    options.output = path_1["default"].resolve(options.cwd, options.output);
    if (options.description) {
        options.description = path_1["default"].resolve(options.cwd, options.description);
    }
    var docTpl = 'doc';
    if (options.format === 'md') {
        docTpl = 'docMd';
    }
    async_1["default"].waterfall([
        function (cb) {
            readTpl_1["default"]([docTpl], cb);
        },
        function (tpl, cb) {
            template = tpl[docTpl];
            cb();
        },
        function (cb) {
            extractCmt_1["default"](ast, options, cb);
        },
        function (cb) {
            readDesc_1["default"](ast, options, cb);
        },
        function (cb) {
            output_1["default"](ast, template, options, cb);
        }
    ], function (err) {
        cb(err);
    });
}
exports["default"] = doc;
;
doc.defOpts = {
    input: 'util' + '.js',
    output: 'doc.html',
    title: 'Eustia Documentation',
    format: 'html'
};
