"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var fs_1 = __importDefault(require("fs"));
var marked_1 = __importDefault(require("marked"));
var logger_1 = __importDefault(require("../../lib/logger"));
var util_1 = __importDefault(require("../../lib/util"));
marked_1["default"].setOptions({
    renderer: new marked_1["default"].Renderer(),
    langPrefix: 'language-'
});
function default_1(ast, template, options, cb) {
    logger_1["default"].tpl({
        output: options.output
    }, 'OUTPUT FILE {{#cyan}}{{{output}}}{{/cyan}}');
    ast.title = options.title;
    if (options.format !== 'md') {
        if (ast.description) {
            ast.description = marked_1["default"](ast.description);
        }
        util_1["default"].each(ast.docs, function (val, key) {
            ast.docs[key] = marked_1["default"](val);
        });
    }
    var data = options.format === 'json' ? JSON.stringify(ast, null, 4) : template(ast);
    fs_1["default"].writeFile(options.output, data, options.encoding, function (err) {
        if (err) {
            return cb(err);
        }
        cb();
    });
}
exports["default"] = default_1;
