"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var async_1 = __importDefault(require("async"));
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var logger_1 = __importDefault(require("./logger"));
function expandPaths(paths, options, cb) {
    var files = [];
    var walker = async_1["default"].queue(function (path, cb) {
        glob_1["default"](path, {
            ignore: options.ignore
        }, function (err, result) {
            logger_1["default"].debug('Expand path', path, 'to', result);
            if (err) {
                return cb(err);
            }
            files = files.concat(result);
            cb();
        });
    }, 50);
    paths.forEach(function (val) {
        walker.push(val);
    });
    walker.drain = function () {
        cb(null, files);
    };
}
function default_1(paths, options, cb) {
    expandPaths(paths, options, function (err, files) {
        if (err) {
            return cb(err);
        }
        async_1["default"].map(files, function (file, cb) {
            fs_1["default"].readFile(file, options.encoding, function (err, data) {
                if (err) {
                    return cb(err);
                }
                cb(null, {
                    path: file,
                    data: data
                });
            });
        }, function (err, results) {
            if (err) {
                return cb(err);
            }
            cb(null, results);
        });
    });
}
exports["default"] = default_1;
